public class DPModel2Decoder extends DPDecoder {
    protected double skipProbability;  //the (log) probability of having fertility 0

    public DPModel2Decoder(ParameterAccessor p, CorpusAccessor c, LanguageModel lm, SortedProbabilityAccessor ntp) {
	super(p, c, lm, ntp);

	skipProbability = -0.90308998699194343; //\log_{10}(0.125)
    }

    public double getSkipProbability() {
    	return skipProbability;
    }

    public void setSkipProbability(double sp) {
    	skipProbability = sp;
    }

    protected double getKnownFertilityProb(int l, String e) {
	//TODO: customize here to address excessive skip-case use in Model 2!
	if (l == 0) {
		return skipProbability;
	} else {
		return 0.0;
	}
    }
    
    protected double getAlignmentProb(int i, int j, int I, int J) {
    	return params.getLogA(i, j, I, J); 
    }
}
