
public class LanguagePair {
    public boolean validPair = true;
    public String sourceTextFile;
    public String destTextFile;
    public String model1Params;
    public String model2Params;
    public String model3Params;
    public String sbpFile;
    public String srilmFile;

    public LanguagePair(String sourceLanguage, String destLanguage) {

	// Spanish-English:
	if (sourceLanguage.equals("es") && destLanguage.equals("en")) {
	    sourceTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.es-en.es";
	    destTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.es-en.en";
	    model1Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.es-en.model1.5iters";
	    model2Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.es-en.model2.5iters";
	    model3Params = "../parameters/textfiles/model3-iter-patched-nosmoothing-4";
	    sbpFile = "../language_models/europarl_2-to-10_stripped.training.es-en.en.ntp.sbp";
	    srilmFile = "../language_models/europarl_2-to-10_stripped.training.es-en.en.lm";
	}
	// English-Spanish:
	else if (sourceLanguage.equals("en") && destLanguage.equals("es")) {
	    sourceTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.es-en.en";
	    destTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.es-en.es";
	    //model1Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.en-to-es.model1.5iters";
	    //model2Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.en-to-es.model2.5iters";
	    //model3Params = "../parameters/textfiles/model3-en-to-es-iter-patched-nosmoothing-4";
	    //sbpFile = "../language_models/europarl_2-to-10_stripped.training.es-en.es.ntp.sbp";
	    //srilmFile = "../language_models/europarl_2-to-10_stripped.training.es-en.es.lm";
	}
	// French-English:
	else if (sourceLanguage.equals("fr") && destLanguage.equals("en")) {
	    sourceTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.fr-en.fr";
	    destTextFile = "../corpora/textpairs/europarl_2-to-10_stripped.training.fr-en.en";
	    // model1Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.fr-to-en.model1.5iters";
	    // model2Params = "../parameters/textfiles/europarl_2-to-10_stripped.training.fr-to-en.model2.5iters";
	    model3Params = "../parameters/textfiles/model3-iter-patched-smoothing-french-4";
	    sbpFile = "../language_models/europarl_2-to-10_stripped.training.fr-en.en.ntp.sbp";
	    srilmFile = "../language_models/europarl_2-to-10_stripped.training.fr-en.en.lm";
	} else {
	    validPair = false;
	}
    }
}