import java.net.*;
import java.io.*;
import java.nio.ByteBuffer;
import java.util.Arrays;

class LMClientwithForking {
	Socket[] socketArray = new Socket[11];
	InputStream[] inArray = new InputStream[11];
	PrintWriter[] outputArray = new PrintWriter[11];
	int responseSize = 14;
	
	public static void main(String[] args) throws IOException {
		LMClientwithForking c = new LMClientwithForking();
		c.open("127.0.0.1", 50000);
		for (int i = 0; i < 100000; i++) {
			System.out.println(c.querySentence("Hello world"));
		}
		c.close();

	
	}
	
	public void open(String addr, int port) throws IOException {
		for (int i =0; i < 11; i++) {
			socketArray[i] = new Socket(addr, port);
			inArray[i] = socketArray[i].getInputStream();
			outputArray[i] = new PrintWriter(socketArray[i].getOutputStream(), true);
		
			byte[] serverMessages = new byte[17];
			int length = 17;
			int offset = 0;
			while (offset < length) {
				offset = inArray[i].read(serverMessages, offset, length);
			}
			
			outputArray[i].println("_R_E_M_O_T_E_L_M_V=2");
		
			length = 4;
			offset = 0;
			while (offset < length) {
				offset = inArray[i].read(serverMessages, offset, length);
			}
		}
	}
	
	public Double queryNgram(String ngram, int socketID) throws IOException {
		String message = "W " + ngram;
		outputArray[socketID].println(message);
		byte[] response = new byte[responseSize];
		int newOffset = 0;
		int offset = 0;
		int lastByte = 2;
		inArray[socketID].skip(3);
		while (response[lastByte-2] != 10) {
			offset = lastByte-2;
			newOffset = inArray[socketID].read(response, offset, responseSize);
			lastByte = offset+newOffset;	
			
			/*System.out.print(lastByte);
			System.out.print("\t");
			System.out.println(response[lastByte-2]);
			System.out.println(new String(response));*/
			//System.out.println(new String(response));
			//System.out.println(response[lastByteIndex-2]);
			//System.out.println(lastByteIndex-2);
		}		
		String strResponse = new String(response);
		//System.out.println(strResponse.length());
		if (strResponse.substring(0,4).equals("-inf")){
			//System.out.println(strResponse.length());
			return 0.0;
		}
		return Double.parseDouble(new String(response));
	}
	
	public Double querySentence(String sentence) throws IOException {
		int order = 2;
		sentence = "<s> " + sentence + " </s>";
		String[] words = sentence.split(" ");
		int length = words.length;
		Double sentenceProb = 0.0;
		int currentSocket = 0;
		
		for (int i = 0; i < length - 1; i++) {
			String ngram = words[i] + " " + words[i+1];
			//System.out.println(ngram);
			Double prob = this.queryNgram(ngram, currentSocket);
			//System.out.println(prob);
			sentenceProb += prob;	
			currentSocket = (currentSocket+1)%11;
		}
		return sentenceProb;
	
	}
	
	public void close() throws IOException {
		for (int i = 0; i < 11; i++) {
			socketArray[i].close();
			outputArray[i].close();
			inArray[i].close();
		}
	}


}