import java.lang.Runtime;
import java.io.*;
import java.net.*;
import java.util.regex.*;



public class LanguageModelServer {

    private int sendPort;
    private Pattern logProb = Pattern.compile("logprob= ([^ ]*)");
    private int receivePort;
    private Runtime runtime = Runtime.getRuntime();
    
	public LanguageModelServer(int srilmPort, int _receivePort) throws IOException {
	
	    sendPort = srilmPort;
	    receivePort = _receivePort;
	    
	    DatagramSocket socket = new DatagramSocket(receivePort);
	    DatagramPacket receivePacket = new DatagramPacket(new byte[255], 255);
	    DatagramPacket sendPacket;
	    	    
	    while (true) {
	        socket.receive(receivePacket);
	        System.out.println("Handling client at " + receivePacket.getAddress().getHostAddress()
	                                                 + " on port " + receivePacket.getPort());
	                                                 
	        String fname = "";
	        try {
			    Process p = runtime.exec("mktemp /tmp/smtXXXX");
			    p.waitFor();
			    BufferedReader stdOutput = new BufferedReader(new InputStreamReader(p.getInputStream()));
			    fname = stdOutput.readLine();
			    stdOutput.close();
			} catch (Exception e) {
			    e.printStackTrace();
			}
			
			
	        String clientMessage = new String(receivePacket.getData());
	        System.out.println(clientMessage);
	        BufferedWriter temp = new BufferedWriter(new FileWriter(fname));
	        temp.write(clientMessage);
	        temp.close();
  
    
	        String srilmResponse = query(fname);
	        
	        Matcher logProbMatcher = logProb.matcher(srilmResponse);
	        logProbMatcher.find();
	        Double logprobability = Double.parseDouble(logProbMatcher.group(1));
	        System.out.println(logprobability);
	        
	        ByteArrayOutputStream buf = new ByteArrayOutputStream();
	        DataOutputStream out = new DataOutputStream(buf);
	        out.writeDouble(logprobability);
	        out.flush();
	        byte[] msg = buf.toByteArray();
	        
	        System.out.println(msg);
	        sendPacket = new DatagramPacket(msg, 8, receivePacket.getAddress(), receivePacket.getPort());
	        socket.send(sendPacket);
	    }
	}
	
	public String query(String fname) {
		String prefix = "/Accounts/bouchara/Desktop/comps/srilm";
		//Runtime runtime = Runtime.getRuntime();
		File srilmFile = new File(prefix+"/bin/macosx");
		String output = "";
		try {
			Process p = runtime.exec("./ngram -use-server "+new String(Integer.toString(sendPort))+"@127.0.0.1 -ppl "+fname, null, srilmFile);
			p.waitFor();
			BufferedReader stdOutput = new BufferedReader(new InputStreamReader(p.getInputStream()));
		    String line = stdOutput.readLine();

		    while (line != null) {
		        System.out.println(line);
		        output+=line;
		        line = stdOutput.readLine();
		    }
		    stdOutput.close();
		
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	return output;
	
	
	
	}
	
	public static void main(String [] args) throws IOException {
	    System.out.println("Hello");
	    /*int port = Integer.parseInt(args[0]);
		String arguments = "";
		for (int i=1; i < args.length; i++) {
			arguments = arguments+args[i]+" ";
		}*/
		LanguageModelServer LMS = new LanguageModelServer(49990,50001);
		//LMS.query("sentences.txt");
	}
}
