import java.util.Arrays;

/**
 * Implements an alignment, which is a mapping of words in the destination
 * sentence to the source sentence. This is an integer array, where the integer n
 * at position i indicates that word i in the destination sentence aligns with word
 * n in the source sentence.
 */
class Alignment {

    private int[] positionArray;
    public double probability = -1;
    public int changedPosition1 = -1;
    public int changedPosition2 = -1;
	
    public Alignment() {}
	
    public Alignment(int[] alignmentArray) {
	positionArray = alignmentArray;
    }
    
    @Override
    public boolean equals(Object alignment) {
	Alignment a = (Alignment) alignment;
	return Arrays.equals(positionArray, a.getAlignment());
    }

    @Override
    public int hashCode() {
	return Arrays.toString(positionArray).hashCode();
    }

    public void setAlignment(int[] alignmentArray) {
	positionArray = alignmentArray;
    }
	
    public int[] getAlignment() {
	return positionArray;
    }
	
    public String getSourceWord(int position, String[] sourceSentence) {
	if (positionArray[position] == 0) {
	    return "_N_U_L_L_";
	}
	else {
	    return sourceSentence[positionArray[position]-1];
	}
    }
	
    public int getFertility(int position) {
	int fertility = 0;
	for (int i = 0; i < positionArray.length; i++) {
	    if (positionArray[i] == position) {
		fertility++;
	    }
	}
	return fertility;
    }
	
    public String toString() {
	return Arrays.toString(positionArray);
    }
	
    public int size() {
	return positionArray.length;
    }
}